#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "math.h" 
#include <string.h>

 // pyl 05/12 
 // 0K 01/2014
 // OK 02/2021
void init()
{ 
  	extern double dx; 
  	extern int nx;
	int i;
	extern double *x,*h,*Z,*dZ,*Q,*u,Fr,h0,xbosse,lbosse,abosse,alpha;
    extern int cas;
	double t10;
          
 	FILE *g = fopen("sol.OUT", "r"); 
	 

    
    
  for(i=0;i<=nx+1;i++)
    {  x[i]=(i-nx/2)*dx;
       
 switch (cas) {
case -1 :  // cas fichier sol.OUT
     fscanf(g,"%lf %lf %lf %lf \n",&x[i],&h[i],&Q[i],&Z[i]);
  	break;
case 0 :   // bosse initiale
     Z[i]=alpha*(x[i]>xbosse)*(x[i]-xbosse);
	// if(x[i]<=xbosse)Z[i]=0; 
	 h[i]=fmax(1+abosse*exp(-x[i]*x[i])-Z[i],0);
     u[i]=0;
     Q[i]=0;
     
	break; 
case 1 :    //dambreak
	 Z[i]=0;
     h[i]=h0*((x[i])<0.0);
     u[i]=0;
     Q[i]=0;
	break;
case 2 :    // ressaut 
	 Z[i]=0;
     h[i]=1+(((-1 + sqrt(1+8*Fr*Fr))/2)-1)*(1+tanh(x[i]))/2;
     Q[i]=Fr;
     u[i]=Q[i]/h[i];
	break;
case 3 :
     Z[i]=0.1*exp(-x[i]*x[i]);
     Q[i]=Fr;
     h[i]=1+Fr*Fr*Z[i]/(Fr*Fr-1) -Z[i];
     u[i]=Fr*(1+Z[i]/(1-Fr*Fr));
	break;
case 4 : //bosse 
	 Z[i]=-alpha*x[i]+abosse*exp(-(0-x[i]/lbosse)*(0-x[i]/lbosse)); 
     h[i]=h0+Z[i]/(Fr*Fr-1);
	 h[i]=h0;//+Fr*Fr*Z[i]/(Fr*Fr-1) -Z[i];
     u[i]=Fr*(1+Z[i]/(1-Fr*Fr));
     Q[i]=Fr*h0;
	break;
case 5 : // lac au repos
	 Z[i]=h0-abosse*exp(-(0-x[i]/lbosse)*(0-x[i]/lbosse));
	 h[i]=h0-Z[i]+0.000*exp(-4*x[i]*x[i]);
	 u[i]=Fr;
	 Q[i]=Fr*h0;
	 break;
case 6 : // tas Hup
	 t10=pow(10,-1./5); 
	 Z[i]=0; 
	 h[i]=h0*(fabs(x[i]*t10)<lbosse);
		 lbosse=sqrt(2);
		 h[i]= 0.5*t10*(fabs(x[i]*t10)<=lbosse)*0.669433*pow(2- x[i]*x[i]*t10*t10,.333333333);
		 Q[i]=1./10*(fabs(x[i]*t10)<=lbosse)* 
		 0.133887 *x[i]* pow(2. - x[i]*x[i]*t10*t10,1./3);
		// u[i]= 0;
		 h[i]=0.25*(fabs(x[i])<=4);
		 Q[i]=0;
		 if(h[i]>0) u[i]=Q[i]/h[i];
		// fprintf(stderr, "%lf %lf %lf %lf \n",x[i],h[i],u[i],Q[i]);				   
	 break;
case 7 : // tas HupZ'
	 Z[i]=-alpha*(x[i]); 
	 h[i]=abosse*(fabs(x[i]-xbosse)<=lbosse);
	 h[i]=abosse*exp(-pow((fabs(x[i]-xbosse)/lbosse),2)); 
	 h[i]=abosse*fmax((x[i]-xbosse)/(lbosse),0)*(x[i]<(xbosse+lbosse)); 
	 Q[i]=0;
	 u[i]=0;
	 if(h[i]>0) u[i]=Q[i]/h[i];
		// fprintf(stderr, "%lf %lf %lf %lf \n",x[i],h[i],u[i],Q[i]);				   
	 break;	 
	 default: 
	 ;
}
    }        
     
    fclose(g);	
     
 for(i=0;i<=nx;i++)
    {  dZ[i]= Z[i+1]-Z[i];	}
    dZ[nx]=0;
}


void lect(int argc, const char * argv[]) 
{
  extern double  dx,t,dt,tmax,Fr,Cf,lbosse,xbosse,abosse,h0,alpha; 
  extern int cas,nx,icl;
  int i;
  FILE *g;
 
 
  if (argc != 2) {
    	 fprintf(stderr, "%i -%s-\n",argc ,argv[1]);
    fprintf(stderr, "usage: svsh donne.in | gnuplot  \n");
//    exit(EXIT_FAILURE);
  }
  
   for(i=0;i<argc;i++){
	fprintf(stderr,"argv[%d] %s \n",i,argv[i]);		}

  if ((g = fopen(argv[1], "r")) == NULL) {
    fprintf(stderr, "Can't open %s\n", argv[1]);
    exit(EXIT_FAILURE);
  }

/* domaine en x et en t                         */    
  
fprintf(stderr,"gg \n");  
fscanf(g,"cas=%i          \n",&cas);          
fscanf(g,"dt=%lf          \n",&dt); 
fscanf(g,"tmax=%lf        \n",&tmax);	
fscanf(g,"dx=%lf          \n",&dx);
fscanf(g,"nx=%i           \n",&nx);  
fscanf(g,"Fr=%lf           \n",&Fr);
fscanf(g,"Cf=%lf           \n",&Cf);
fscanf(g,"icl=%i           \n",&icl);
fscanf(g,"h0=%lf           \n",&h0); 
fscanf(g,"xbosse=%lf       \n",&xbosse);
fscanf(g,"lbosse=%lf       \n",&lbosse);
fscanf(g,"abosse=%lf       \n",&abosse);
fscanf(g,"alpha=%lf        \n",&alpha);


fclose(g); 
	g = fopen("solxhQZ.OUT", "w");
	fclose(g);
	g = fopen("solxhFront.OUT", "w");
	fclose(g);  
 
  t=0;	  

//   	
	
  fprintf(stderr,"  ----------------------------------------------\n");	
  fprintf(stderr,"  |--->             |--->                       \n");   
  fprintf(stderr,"  |--->             |--->                       \n");   
  fprintf(stderr,"  ----------------------------------------------\n");
   
}    


/* ------------------------------------------------------------------------*/ 

void ecrit()
{    
	extern double  dx,t,dt,tmax; 
  	extern int nx;
	int i;
	double y1,y2,xf,hf;
	extern double *x,*h,*Z,*dZ,*Q,Fr,e;
	FILE *g;
	extern int cas;
 
	/* Saving the fields */ 

	
	
	g = fopen("solxhQZ.OUT", "a");
	for (i=0; i<=nx+1;i++)
	{      fprintf(g,"%lf %lf %lf %lf \n",x[i],h[i]+Z[i],Q[i],t);}
	 fprintf(g,"\n");
	 fclose(g);


	
	xf=-1000;
	hf=-10;
	for (i=nx; i>=0;i--)
	{   
		if((h[i]>hf))hf=h[i];
	 }
	 
	 
	for (i=nx; i>=0;i--)
	{   
		if((h[i]>hf/2)&&(xf<x[i]))xf=x[i];
	}
	
	 fprintf(stderr,"%lf %lf %lf \n",t,xf,hf);
		 
	g = fopen("solxhFront.OUT", "a");
	{      fprintf(g,"%lf %lf %lf \n",t,xf,hf);}

	fclose(g);
	
	
	
	
	
    g = fopen("solxhQZinst.OUT", "w");
	for (i=0; i<=nx+1;i++)
	{      fprintf(g,"%lf %lf %15.13f %lf %lf %lf \n",x[i],h[i],Q[i],Z[i],xf,hf);}
	fprintf(g,"\n");
	fclose(g);
	
// sortie GNUPLOT	
	
	
	printf("t=%lf\n",t);
	printf("set xlabel \"x\" ; set title \"t=%lf  e=%lf \"\n",t,e); 
 switch (cas) {
case 0 :  
    y1=-.1,y2=1.5;
	printf("h(x)=1 \n");
	break; 	
case 1 :   //dambreak
	y1=-.1,y2=1.25;	
	printf("set label \"+\" at 0,.296296296296296 \n"); 
	printf("h(x)=(((x-0)<-t)+((x-0)>-t)*(2./3*(1-(x-0)/(2*t)))**2)*(((x-0)<2*t)) \n");
	break;
case 2 :  // ressaut 
	y1=0,y2=(-1+sqrt(1+ 8*Fr*Fr))/2-1; ;	 
	printf("h(x)=(%lf)*(x>0)+1 \n",y2); 
	y2=fmax(2,y2+1.5);
	break;
case 3 :
     printf("h(x)=1+ (%lf**2)*0.1*exp(-x*x)/( (%lf**2)-1) \n",Fr,Fr); 
     y1=0,y2=fmin(1.5,1.5*Fr);
    break;	
case 4 :
     printf("h(x)=1+0.125*exp(-(0-x/5)*(0-x/5))*(%lf**2) /(%lf**2-1)  \n",Fr,Fr); 
     y1=0,y2=fmin(2,2);
    break;	
case 6 :
		 
		// printf("h(x)=(%lf**(-3./5))*(x*(%lf**(-1./5)))* 0.133887*(2-(x*(%lf**(-1./5)))**2)**(1./3); \n",
		//		t+1,t+1,t+1); 
		// printf("h(x)=(%lf**(-1./5))* 0.669433 *(2-(x*(%lf**(-1./5)))**2)**(1./3); \n",t,t,t); 
		 xf=2.45*pow(t,.2);
		 hf=0.53*pow(t,-.2);
		 xf = 1/(0.841309*hf);
		 printf("h(x)=%lf*(1-(x/%lf*1.0)**2)**(1./3); \n",hf,xf); 
		 y1=-0.05;y2=.25;
	 break;	
	 default :
	y1=0,y2=1.5;	 
	printf("h(x)= 1 \n");  ;	
}
	 
	printf("p[%lf:%lf][%lf:%lf] h(x) t'h exact','-' u 1:2 t'Q'  w l,'-'  t'h' w d,'-'  t'Z' w l linec -1\n ",
			   -nx*dx/2,nx*dx/2,y1,y2); 
		for (i=0; i<=nx;i++)
		{
			printf("%lf %lf \n",x[i],Q[i]);}
		printf("e \n");
		for (i=0; i<=nx;i++)
		{
			printf("%lf %lf \n",x[i],h[i]+Z[i]);}
		printf("e \n");
		for (i=0; i<=nx;i++)
		{
			printf("%lf %lf \n",x[i],Z[i]);}
		printf("e \n");
	
	
	
}






